package du10;

import java.io.PrintStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author votavon1
 */
public class Du10Test {
    private static int parseReply(String rep){
        String[] reply = rep.split("[\\s,.:]");
        int parsed = -1;
        for(int i = reply.length - 1; i >=0; i--){
            if(reply[i].matches("[\\d]+")){
                parsed = Integer.parseInt(reply[i]);
                break;
            }
        }
        return parsed;
    }

    public Du10Test() {
    }

    @Test
    public void testPocetDnuUser(){
        InputStream sin = System.in;
        PrintStream sout = System.out;

        String vstup = "2000\n3\n1";
        System.setIn(new ByteArrayInputStream(vstup.getBytes()));
        ByteArrayOutputStream bos = new ByteArrayOutputStream(1000);
        PrintStream ps = new PrintStream(bos, true);
        System.setOut(ps);

        Du10.pocetDnuUser();

        int parsed = parseReply(bos.toString());
        int expected = 61;
        assertEquals(expected, parsed);

        bos.reset();

        vstup = "1200\n1\n1\n1900\n1\n31";
        System.setIn(new ByteArrayInputStream(vstup.getBytes()));
        Du10.pocetDnuUser();
        parsed = parseReply(bos.toString());
        expected = 31;
        assertEquals(expected, parsed);

        bos.reset();

        vstup = "195s\n1s\n1s\n1980\n2\n29";
        System.setIn(new ByteArrayInputStream(vstup.getBytes()));
        Du10.pocetDnuUser();
        parsed = parseReply(bos.toString());
        expected = 60;
        assertEquals(expected, parsed);

        bos.reset();

        vstup = "2011\n12\n31";
        System.setIn(new ByteArrayInputStream(vstup.getBytes()));
        Du10.pocetDnuUser();
        parsed = parseReply(bos.toString());
        expected = 365;
        assertEquals(expected, parsed);

        bos.reset();

        vstup = "1992\n1\n21";
        System.setIn(new ByteArrayInputStream(vstup.getBytes()));
        Du10.pocetDnuUser();
        parsed = parseReply(bos.toString());
        expected = 21;
        assertEquals(expected, parsed);

        bos.reset();

        System.setOut(sout);
        System.setIn(sin);
    }

}